----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:22:58 08/27/2008 
-- Design Name: 
-- Module Name:    buffer_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity buffer_ctrl is
    Port (clk : in  STD_LOGIC;
          strobe : in std_logic;
          reset : in std_logic;
          run : in std_logic;
          vme_rd_mem : in  STD_LOGIC;
					vme_rd_wc : in std_logic_vector(4 downto 0);
					vme_rd_wait: out std_logic;
          vme_end : in  STD_LOGIC;
          vme_we_mem : in  STD_LOGIC;
					w_data : in std_logic_vector(31 downto 0);
					ddr_pa : in std_logic_vector(13 downto 0);
					addr : in std_logic_vector(9 downto 0);
					lfifo_req : in std_logic_vector(2 downto 0);
					lfifo_we : in std_logic_vector(2 downto 0);
          lfifoA_data : in std_logic_vector(32 downto 0);
          lfifoB_data : in std_logic_vector(32 downto 0);
          lfifoC_data : in std_logic_vector(32 downto 0);
          lfifo_ack : out std_logic_vector(2 downto 0);
-- ddr read/write queue signals
					ddr_rqst: out std_logic;
					ddr_read: out std_logic;
					ddr_gnt: in std_logic;
					ddr_addr: out STD_LOGIC_VECTOR (22 downto 0);
					ddr_length: out STD_LOGIC_VECTOR (5 downto 0);
-- 
					wr_data: out STD_LOGIC_VECTOR (31 downto 0);
					wr_en: out std_logic;
					rd_en: out STD_LOGIC;
-- output signals					
          data_fifo_afull : in std_logic;
          rd_event : in std_logic;
          evt_param : in std_logic_vector(22 downto 0);
					reg_data: in STD_LOGIC_VECTOR (31 downto 0);
					mem_data: in STD_LOGIC_VECTOR (31 downto 0);
					dbg_cntr0: out STD_LOGIC_VECTOR (31 downto 0);
					dbg_cntr1: out STD_LOGIC_VECTOR (31 downto 0);
					dbg_cntr2: out STD_LOGIC_VECTOR (31 downto 0);
					out_data: out STD_LOGIC_VECTOR (35 downto 0)
		);
end buffer_ctrl;

architecture Behavioral of buffer_ctrl is
signal inh_ack: std_logic :='0';
signal lfifo_ack_i: std_logic_vector(2 downto 0) := (others => '0');
signal lrb_ch: std_logic_vector(1 downto 0) := (others => '0');
signal wr_en_i: std_logic_vector(1 downto 0) := (others => '0');
signal d_waddr_l: std_logic_vector(8 downto 0) := (others => '0');
signal d_waddr_h: std_logic_vector(7 downto 0) := (others => '0');
signal waddr_l: std_logic_vector(8 downto 0) := (others => '0');
signal waddr_h: std_logic_vector(7 downto 0) := (others => '0');
signal we_waddr_hp: std_logic :='0';
signal we_waddr_lp: std_logic :='0';
signal we_waddr_h: std_logic :='0';
signal we_waddr_l: std_logic :='0';
signal blk_length: std_logic_vector(5 downto 0) := (others => '0');
signal wqueue_i: std_logic_vector(31 downto 0) := (others => '0');
signal wqueue_o: std_logic_vector(31 downto 0) := (others => '0');
signal wqueue_wa: std_logic_vector(8 downto 0) := (others => '0');
signal wqueue_ra: std_logic_vector(8 downto 0) := (others => '0');
signal we_wqueue: std_logic :='0';
signal dav_wqueue: std_logic :='0';
signal re_wqueue: std_logic :='0';
signal rot_p: std_logic_vector(1 downto 0) := (others => '0');
signal end_of_event: std_logic_vector(1 downto 0) := (others => '0');
signal rst_waddr_h: std_logic :='0';
signal mem2reg: std_logic :='0';
signal vme_pending: std_logic :='0';
signal rst_length: std_logic :='0';
signal rp_rqueue: std_logic_vector(3 downto 0) := (others => '0');
signal rqueue_o: std_logic_vector(22 downto 0) := (others => '0');
signal rd_rqst: std_logic :='1';
signal re_rqueue: std_logic :='0';
signal re_rqueue_h: std_logic :='0';
signal dav_rqueue: std_logic :='0';
signal rd_blk: std_logic_vector(2 downto 0) := (others => '0');
signal sel_out: std_logic_vector(1 downto 0) := (others => '0');
signal sel_outp: std_logic_vector(1 downto 0) := (others => '0');
signal info_di: std_logic_vector(35 downto 0) := (others => '0');
signal info_do: std_logic_vector(35 downto 0) := (others => '0');
--signal info_dop: std_logic_vector(35 downto 0) := (others => '0');
signal info_fifo_wa: std_logic_vector(8 downto 0) := (others => '0');
signal info_fifo_ra: std_logic_vector(8 downto 0) := (others => '0');
signal info_fifo_rap: std_logic_vector(8 downto 0) := (others => '0');
signal d_info_wa: std_logic_vector(1 downto 0) := (others => '0');
signal info_wa: std_logic_vector(1 downto 0) := (others => '0');
signal wr_data_i: std_logic_vector(31 downto 0) := (others => '0');
signal rd_wc: std_logic_vector(8 downto 0) := (others => '0');
signal rp_oqueue: std_logic_vector(3 downto 0) := (others => '0');
signal oqueue_i: std_logic_vector(6 downto 0) := (others => '0');
signal oqueue_o: std_logic_vector(6 downto 0) := (others => '0');
signal mem_wc: std_logic_vector(6 downto 0) := (others => '0');
signal rd_length_i: std_logic_vector(6 downto 0) := (others => '0');
signal ddr_length_i: std_logic_vector(5 downto 0) := (others => '0');
signal last_blk: std_logic :='0';
signal boe: std_logic :='0';
signal eoe: std_logic :='0';
signal we_oqueue: std_logic :='0';
signal we_oqueuep: std_logic :='0';
signal re_oqueue: std_logic :='0';
signal dav_oqueue: std_logic :='0';
signal rd_en_i: std_logic :='0';
signal we_info_que: std_logic :='0';
signal dav_info_que: std_logic :='0';
signal we_info_wa: std_logic :='0';
signal ddr_rqst_i: std_logic :='0';
signal ddr_read_i: std_logic :='0';
signal rqueue_cntr: std_logic_vector(15 downto 0) := (others => '0');
signal debug0: std_logic_vector(31 downto 0) := (others => '0');
signal debug1: std_logic_vector(31 downto 0) := (others => '0');
signal debug2: std_logic_vector(31 downto 0) := (others => '0');
begin
dbg_cntr0 <= debug0;
dbg_cntr1<= debug1;
dbg_cntr2 <= debug2;
rd_en <= rd_en_i;
ddr_rqst <= ddr_rqst_i;
ddr_read <= ddr_read_i;
ddr_length <= ddr_length_i;
lfifo_ack <= lfifo_ack_i;
vme_rd_wait <= dav_info_que;
process(clk)
begin
	if(clk'event and clk = '1')then
			if(vme_rd_mem = '1')then -- this implies run = '0' and no other request could happen at the same time
				ddr_addr <= ddr_pa & addr(8 downto 0);
				ddr_length_i <= "00" & vme_rd_wc(3 downto 0);
			elsif(ddr_read_i = '1')then
				ddr_addr <= rqueue_o(22 downto 9) & rd_blk & "000000";
				ddr_length_i <= rd_length_i(5 downto 0);
			elsif(re_wqueue = '1')then
				ddr_addr <= wqueue_o(22 downto 0);
				ddr_length_i <= wqueue_o(28 downto 23);
			end if;
	end if;
end process;
process(clk)
begin
	if(clk'event and clk = '1')then
--		if(strobe = '1')then
			if(lfifo_ack_i /= "000")then
				inh_ack <= '1';
			elsif(reset = '1' or lfifo_we /= "000")then
				inh_ack <= '0';
			end if;
			if(reset = '1')then
				lrb_ch(1) <= not lrb_ch(1) and lrb_ch(0);
				lrb_ch(0) <= not lrb_ch(1) and not lrb_ch(0);
			else
				lrb_ch(1) <= not lfifo_we(1) and not lfifo_we(0) and (lfifo_we(2) or lrb_ch(1));
				lrb_ch(0) <= not lfifo_we(2) and not lfifo_we(0) and (lfifo_we(1) or lrb_ch(0));
			end if;
			if(lfifo_ack_i /= "000")then
				rot_p(1) <= not rot_p(1) and rot_p(0);
				rot_p(0) <= not rot_p(1) and not rot_p(0);
			end if;
			if(inh_ack = '1' or lfifo_ack_i /= "000")then
				lfifo_ack_i <= "000";
			elsif(lfifo_we = "000")then
				if(lfifo_req(2) = '1' and (rot_p(1) = '1' or ((rot_p(0) = '0' or lfifo_req(1) = '0') and lfifo_req(0) = '0')))then
					lfifo_ack_i(2) <= '1';
				else
					lfifo_ack_i(2) <= '0';
				end if;
				if(lfifo_req(1) = '1' and (rot_p(0) = '1' or ((rot_p(1) = '1' or lfifo_req(0) = '0') and lfifo_req(2) = '0')))then
					lfifo_ack_i(1) <= '1';
				else
					lfifo_ack_i(1) <= '0';
				end if;
				if(lfifo_req(0) = '1' and (rot_p = "00" or ((rot_p(1) = '0' or lfifo_req(2) = '0') and lfifo_req(1) = '0')))then
					lfifo_ack_i(0) <= '1';
				else
					lfifo_ack_i(0) <= '0';
				end if;
			end if;
			if(run = '1' or vme_end = '1' or reset = '1')then
				mem2reg <= '1';
			elsif(vme_rd_mem = '1')then
				mem2reg <= '0';
			end if;
			if(run = '1')then
				wr_en <= wr_en_i(0);
				wr_data <= wr_data_i;
			else
				wr_en <= vme_we_mem and strobe;
				wr_data <= w_data;
			end if;
			wr_en_i(0) <= lfifo_we(2) or lfifo_we(1) or lfifo_we(0);
			wr_data_i <= lfifoA_data(31 downto 0) or lfifoB_data(31 downto 0) or lfifoC_data(31 downto 0);
			end_of_event(0) <= lfifoA_data(32) or lfifoB_data(32) or lfifoC_data(32);
			wr_en_i(1) <= wr_en_i(0);
			end_of_event(1) <= end_of_event(0);
			if(reset = '1' or we_wqueue = '1')then
				vme_pending <= '0';
			elsif(strobe = '1' and vme_we_mem = '1')then
				vme_pending <= '1';
			end if;
			if(run = '1')then
				we_wqueue <= end_of_event(1) or (wr_en_i(1) and not wr_en_i(0));
			elsif(we_wqueue = '1')then
				we_wqueue <= '0';
			else
				we_wqueue <= (vme_end or not or_reduce(addr(5 downto 0))) and vme_pending;
			end if;
			if(run = '0')then
				rst_length <= not vme_pending;
			else
				rst_length <= end_of_event(0) or not wr_en_i(0);
			end if;
			if(rst_length = '1')then
				blk_length <= (others => '0');
			elsif(run = '1' or (strobe = '1' and vme_we_mem = '1'))then
				blk_length <= blk_length + 1;
			end if;
			we_waddr_hp <= reset or end_of_event(0);
			rst_waddr_h <= reset;
			we_waddr_lp <= reset or end_of_event(0) or (wr_en_i(1) and not wr_en_i(0) and not end_of_event(1));		
			if(run = '1')then
				wqueue_i(22 downto 0) <= x"0" & lrb_ch & waddr_h & waddr_l;
			elsif(vme_pending = '0')then
				wqueue_i(22 downto 0) <= ddr_pa & addr(8 downto 0);
			end if;
			wqueue_i(28 downto 23) <= blk_length;
--		end if;
	end if;
end process;
g_waddr_h: for i in waddr_h'range generate
	i_waddr_h : RAM16X1S
		port map (
      O => waddr_h(i),     -- Read/Write port 1-bit output
      A0 => lrb_ch(0),       -- RAM address[0] input bit
      A1 => lrb_ch(1),       -- RAM address[1] input bit
      A2 => '0',       -- RAM address[2] input bit
      A3 => '0',       -- RAM ddress[3] input bit
      D => d_waddr_h(i),         -- RAM 1-bit data input
      WCLK => clk,   -- Write clock input
      WE => we_waddr_h   -- Write enable input
   );
end generate;
we_waddr_h <= we_waddr_hp;-- and strobe;
d_waddr_h <= (others => '0') when rst_waddr_h = '1' else wqueue_i(16 downto 9) + 1;
g_waddr_l: for i in waddr_l'range generate
	i_waddr_l : RAM16X1S
		port map (
      O => waddr_l(i),     -- Read/Write port 1-bit output
      A0 => lrb_ch(0),       -- RAM address[0] input bit
      A1 => lrb_ch(1),       -- RAM address[1] input bit
      A2 => '0',       -- RAM address[2] input bit
      A3 => '0',       -- RAM ddress[3] input bit
      D => d_waddr_l(i),         -- RAM 1-bit data input
      WCLK => clk,   -- Write clock input
      WE => we_waddr_l   -- Write enable input
   );
end generate;
we_waddr_l <= we_waddr_lp;-- and strobe;
d_waddr_l <= (others => '0') when we_waddr_hp = '1' else wqueue_i(8 downto 0) + wqueue_i(28 downto 23) + 1;
i_wqueue : RAMB16_S36_S36
   port map (
      DOB => wqueue_o,      -- Port B 32-bit Data Output
      ADDRA => wqueue_wa,  -- Port A 9-bit Address Input
      ADDRB => wqueue_ra,  -- Port B 9-bit Address Input
      CLKA => clk,    -- Port A 1-bit Clock
      CLKB => clk,    -- Port B 1-bit Clock
      DIA => wqueue_i,      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A 1-bit RAM Enable Input
      ENB => strobe,      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => we_wqueue,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			wqueue_wa <= (others => '0');
		elsif(we_wqueue = '1')then
			wqueue_wa <= wqueue_wa + 1;
		end if;
		if(strobe = '1')then
			if(reset = '1')then
				wqueue_ra <= (others => '0');
			elsif(re_wqueue = '1')then
				wqueue_ra <= wqueue_ra + 1;
			end if;
			if(wqueue_wa = wqueue_ra)then
				dav_wqueue <= '0';
			else
				dav_wqueue <= '1';
			end if;
		end if;
	end if;
end process;
g_info_wa: for i in 0 to 1 generate
	i_info_wa : RAM16X1S
		port map (
      O => info_wa(i),     -- Read/Write port 1-bit output
      A0 => lrb_ch(0),       -- RAM address[0] input bit
      A1 => lrb_ch(1),       -- RAM address[1] input bit
      A2 => '0',       -- RAM address[2] input bit
      A3 => '0',       -- RAM ddress[3] input bit
      D => d_info_wa(i),         -- RAM 1-bit data input
      WCLK => clk,   -- Write clock input
      WE => we_info_wa   -- Write enable input
   );
end generate;
d_info_wa <= "00" when reset = '1' or end_of_event(0) = '1' else info_wa + 1;
--we_info_wa <= strobe and ((wr_en_i(0) and (not info_wa(1) or not info_wa(0) or end_of_event(0))) or reset);
we_info_wa <= (wr_en_i(0) and (not info_wa(1) or not info_wa(0) or end_of_event(0))) or reset;
i_infoqueue : RAMB16_S36_S36
   port map (
      DOB => info_do(31 downto 0),      -- Port B 32-bit Data Output
      DOPB => info_do(35 downto 32),      -- Port B 4-bit parity Output
      ADDRA => info_fifo_wa,  -- Port A 9-bit Address Input
      ADDRB => info_fifo_ra,  -- Port B 9-bit Address Input
      CLKA => clk,    -- Port A 1-bit Clock
      CLKB => clk,    -- Port B 1-bit Clock
      DIA => info_di(31 downto 0),      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => info_di(35 downto 32),    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A 1-bit RAM Enable Input
      ENB => strobe,      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => we_info_que,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
g_info_fifo_ra: for i in info_fifo_ra'range generate
	i_info_fifo_ra: delayN
		generic map(N=> 2) port map(d => info_fifo_rap(i), ce => strobe, c => clk, q => info_fifo_ra(i));
end generate;
process(clk)
begin
	if(clk'event and clk = '1')then
--		if(strobe = '1')then
			if(wr_en_i(0) = '1' and (info_wa /= "11" or end_of_event(0) = '1'))then
				we_info_que <= '1';
			else
				we_info_que <= '0';
			end if;
			if(reset = '1')then
				info_fifo_wa <= (others => '0');
			elsif(we_info_que = '1')then
				info_fifo_wa <= info_fifo_wa + 1;
			end if;
			if(info_wa = "00" and end_of_event(0) = '0')then
				info_di <= "000" & end_of_event(0) & wr_data_i(31 downto 26) & lrb_ch & wr_data_i(23 downto 10) & wr_data_i(25 downto 24) & wr_data_i(7 downto 0);
			else
				info_di <= "000" & end_of_event(0) & wr_data_i(31 downto 26) & lrb_ch & wr_data_i(23 downto 0);
			end if;
		if(strobe = '1')then
			if(reset = '1')then
				info_fifo_rap <= (others => '0');
			elsif(info_fifo_wa /= info_fifo_rap)then
				info_fifo_rap <= info_fifo_rap + 1;
			end if;
			if(info_fifo_wa = info_fifo_rap)then
				dav_info_que <= '0';
			else
				dav_info_que <= '1';
			end if;
		end if;
	end if;
end process;
i_rqueue_h : srl_fifo
  generic map (N => 14)
  port map(
	rst => reset,
	din => evt_param(22 downto 9),
	clk => clk,
	w_strobe => strobe,
	we => rd_event,
	r_strobe => strobe,
	re => re_rqueue_h,
	dout => rqueue_o(22 downto 9));
i_rqueue_l : srl_fifo
  generic map (N => 9)
  port map(
	rst => reset,
	din => evt_param(8 downto 0),
	clk => clk,
	w_strobe => strobe,
	we => rd_event,
	r_strobe => strobe,
	re => re_rqueue,
	rp => rp_rqueue,
	dav => dav_rqueue,
	dout => rqueue_o(8 downto 0));
process(clk)
begin
	if(clk'event and clk = '1')then
		if(strobe = '1')then
			if(ddr_gnt = '1' and ddr_read_i = '1' and rd_length_i(6) = '1')then
				re_rqueue_h <= '1';
			else
				re_rqueue_h <= '0';
			end if;
			if(reset = '1' or (ddr_gnt = '1' and ddr_read_i = '1' and rd_length_i(6) = '1'))then
				rd_rqst <= '0';
			elsif(re_rqueue = '1')then
				rd_rqst <= '1';
			end if;
			if(dav_rqueue = '1' and rd_rqst = '0' and re_rqueue = '0')then
				re_rqueue <= '1';
			else
				re_rqueue <= '0';
			end if;
			if(reset = '1')then
				debug0 <= (others => '0');
			elsif(re_rqueue = '1')then
				debug0 <= debug0 + (x"00000" & "000" & rd_wc) + 1;
			end if;
			if(reset = '1')then
				debug1 <= (others => '0');
			elsif(re_rqueue = '1')then
				debug1 <= debug1 + 1;
			end if;
			if(reset = '1')then
				debug2(31) <= '0';
			elsif(rd_event = '1' and rp_rqueue = x"e")then
				debug2(31) <= '1';
			end if;
			debug2(30 downto 16) <= '0' & dav_rqueue & rd_rqst & "000" & rd_wc;
			if(reset = '1')then
				rqueue_cntr <= (others => '0');
			elsif(re_rqueue /= rd_event)then
				if(re_rqueue = '1')then
					rqueue_cntr <= rqueue_cntr - 1;
				else
					rqueue_cntr <= rqueue_cntr + 1;
				end if;
			end if;
			if(reset = '1')then
				debug2(15 downto 0) <= (others => '0');
			elsif(rqueue_cntr > debug2(15 downto 0))then
				debug2(15 downto 0) <= rqueue_cntr + 1;
			end if;
			if(reset = '1')then
				rd_wc <= (others => '0');
			elsif(rd_rqst = '0')then
				rd_wc <= rqueue_o(8 downto 0);
			elsif(ddr_gnt = '1' and ddr_read_i = '1')then
				rd_wc(8 downto 6) <= rd_wc(8 downto 6) - 1;
			end if;
			if(re_rqueue = '1')then
				rd_blk <= "000";
			elsif(ddr_gnt = '1' and ddr_read_i = '1')then
				rd_blk <= rd_blk + 1;
			end if;
			if(ddr_rqst_i = '0')then
				ddr_read_i <= not dav_wqueue;
			end if;
			re_wqueue <= not ddr_rqst_i and dav_wqueue;
			if(reset = '1' or ddr_gnt = '1')then
				ddr_rqst_i <= '0';
			elsif(vme_rd_mem = '1' or (rd_rqst = '1' and rp_oqueue(3 downto 2) /= "01") or dav_wqueue = '1')then
				ddr_rqst_i <= '1';
			end if;
			if(rd_wc(8 downto 6) = "000")then
				rd_length_i <= '1' & rd_wc(5 downto 0);
			else
				rd_length_i <= "0111111";
			end if;
			if(ddr_gnt = '1' and ddr_read_i = '1')then
				oqueue_i <= rd_length_i(6) & ddr_length_i;
			end if;
			we_oqueuep <= ddr_gnt and ddr_read_i;
--			if(reset = '1')then
--				debug1 <= (others => '0');
--			elsif(we_oqueue = '1')then
--				debug1 <= debug1 + (x"000000" & "00" & oqueue_i(5 downto 0)) + 1;
--			end if;
		end if;
	end if;
end process;
i_oqueue : srl_fifo
  generic map (N => 7)
  port map(
	rst => reset,
	din => oqueue_i,
	clk => clk,
	w_strobe => strobe,
	we => we_oqueue,
	r_strobe => strobe,
	re => re_oqueue,
	rp => rp_oqueue,
	dav => dav_oqueue,
	dout => oqueue_o);
i_we_oqueue: delayN
  generic map(N=> 2) port map(d => we_oqueuep, ce => strobe, c => clk, q => we_oqueue);
process(clk)
begin
	if(clk'event and clk = '1')then
		if(strobe = '1')then
			re_oqueue <= dav_oqueue and not mem_wc(6);
--			if(reset = '1')then
--				debug2 <= (others => '0');
--			elsif(mem_wc(6) = '0' and dav_oqueue = '1')then
--				debug2 <= debug2 + (x"00000" & "000" & oqueue_o(5 downto 0)) + 1;
--			end if;
			if(reset = '1')then
				mem_wc <= (others => '0');
			elsif(vme_rd_wc(4) = '0' and dav_info_que = '0' and mem_wc(6) = '1' and data_fifo_afull = '0')then
				mem_wc <= mem_wc + 1;
			elsif(mem_wc(6) = '0' and dav_oqueue = '1')then
				mem_wc <= '1' & not oqueue_o(5 downto 0);
			end if;
			if(mem_wc(6) = '0' and dav_oqueue = '1')then
				last_blk <= oqueue_o(6);
			end if;
			if(vme_rd_wc(4) = '0' and dav_info_que = '0' and mem_wc(6) = '1' and data_fifo_afull = '0')then
				rd_en_i <= '1';
			else
				rd_en_i <= '0';
			end if;
			if(run = '0')then
				boe <= '0';
			elsif(reset = '1' or eoe = '1')then
				boe <= '1';
			elsif(vme_rd_wc(4) = '0' and dav_info_que = '0' and mem_wc(6) = '1' and data_fifo_afull = '0')then
				boe <= '0';
			end if;
			eoe <= last_blk and rd_en_i and not mem_wc(6);
			if(reset = '1')then
				sel_outp <= "00";
				sel_out <= "00";
			else
				sel_outp(1) <= vme_rd_wc(4) or dav_info_que;
				sel_outp(0) <= not dav_info_que and (vme_rd_wc(4) or (mem_wc(6) and not data_fifo_afull));
				sel_out <= sel_outp;
			end if;
			case sel_out is
				when "01" => out_data <= '1' & mem2reg & boe & eoe & mem_data;
				when "10" => out_data <= "101" & info_do(32 downto 0);
				when "11" => out_data <= x"9" & reg_data;
				when others => out_data <= (Others => '0');
			end case;
		end if;
	end if;
end process;
end Behavioral;

