----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:28:51 12/19/2008 
-- Design Name: 
-- Module Name:    mq - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mq_cell is
    Port ( mq_i : in  STD_LOGIC;
           dqs : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           clkn : in  STD_LOGIC;
           en_dqs : in  STD_LOGIC;
           sel_in : in  STD_LOGIC_VECTOR(1 downto 0);
           sel_out : in  STD_LOGIC_VECTOR(1 downto 0);
           q0 : out  STD_LOGIC;
           q1 : out  STD_LOGIC);
end mq_cell;

architecture Behavioral of mq_cell is
signal q_r : std_logic_vector(1 downto 0) := "00";
signal q_f : std_logic_vector(1 downto 0) := "00";
signal q : std_logic_vector(1 downto 0) := "00";
attribute IOB : string;
attribute IOB of q_r, q_f : signal is "false";
begin
process(dqs)
begin
	if(dqs'event and dqs = '1')then
		if(en_dqs = '1')then
			q_r(0) <= (mq_i and not sel_in(1)) or (q_r(0) and sel_in(1));
			q_r(1) <= (mq_i and sel_in(1)) or (q_r(1) and not sel_in(1));
		end if;
	end if;
end process;
process(dqs)
begin
	if(dqs'event and dqs = '0')then
		if(en_dqs = '1')then
			q_f(0) <= (mq_i and not sel_in(0)) or (q_f(0) and sel_in(0));
			q_f(1) <= (mq_i and sel_in(0)) or (q_f(1) and not sel_in(0));
		end if;
	end if;
end process;
process(clk)
begin
	if(clk'event and clk = '1')then
		if(sel_out(1) = '1')then
			q(0) <= q_r(0);
		else
			q(0) <= q_r(1);
		end if;
		q0 <= q(0);
		q1 <= q(1);
	end if;
end process;
process(clkn)
begin
	if(clkn'event and clkn = '1')then
		if(sel_out(0) = '1')then
			q(1) <= q_f(0);
		else
			q(1) <= q_f(1);
		end if;
	end if;
end process;
end Behavioral;

